# Jabber Bot : spreads trough jabber
# the things you whisper in its ear
#
# You can get nagios notifications through
# your corporate IM system, for example :)
#
# By Nico <nico@gcu-squad.org>
# This code is under the BSD Licence


require 'rubygems'
require 'xmpp4r-simple'
require 'socket'


class RubyBot
  #Initializes the ruby bot with its jid and password.
  def initialize(jid, pass)
    @jid = jid
    @pass = pass
    connect()
  end
  
  #Connects the bot to the jabber server.
  def connect()
    @bot = Jabber::Simple.new(@jid, @pass, :chat, 'Nagios talking')
  end
  
  #Sends a message to a single recipient (given by jid).
  def send_msg(user, message)
    @bot.deliver(user,message)
  end
  
  #Broadcasts a message to recipients (given as an array of jids).
  def send_mass_msg(users, message)
    users.each do |user|
      @bot.deliver(user,message)
    end
  end
  
  #Sets up the ruby bot's callbacks.
  def setup_callbacks
    @cb = Callbacks.new(self)
    @cb.chat_callbacks.each do |cb|
      @bot.client.add_message_callback(0,&cb)
    end   
  end
  
end
module Chat
  def on_message(message)
    
    begin
      if message.body
        sender = message.from
        message = message.body
        
        result = case message
               
        when /^%.*%$/
          process_commands(message)
        else 
          "Try %help% dude"
        end
        
        if @parent
          @parent.send_msg(sender, result) rescue Exception
        else
          puts result
        end
      end
      
      # Let's work with the commands
      def process_commands(command)
      	command.delete!('%')
		  	result = case command
		  	when "help"
		  		return "help command"
		  	
		  	when "stop"
		  		return "stop command"
		  	
		  	else
		  		"Hey, I'm not stupid !"
		  	end
		  	
		  	return result
      end
      
      rescue Exception =>e
      p e
    end
    
    result || ""
  end
end  

class Callbacks
  include Chat
  
  attr_accessor :chat_callbacks
  
  def initialize(parent=nil)
    @parent = parent
    
    @chat_callbacks = Chat.instance_methods.collect do |name|
      self.method(name).to_proc if name=~/^on_/
    end
  end
  
end


class NotifyBot
	
	def initialize(bot,port)
		@bot=bot
		@server = TCPServer.new(port)
		# Accounts to be notified when the bot gets a message.
		@dests = [ 'account1@server', 'account2@server' ]
	end

	def run
		while (session = @server.accept)
		 	msg=session.gets
  		session.close

  		@dests.each do |d|
	  		@bot.send_msg(d, msg)
	  	end
	  	
		end
	end

end
